# 23apr23 Software Lab. Alexander Burger

"Battery"

(symbols '(android pico))

(local) (*BatteryManager getIntProperty BATTERY_PROPERTY_CURRENT_NOW
BATTERY_PROPERTY_CURRENT_AVERAGE BATTERY_PROPERTY_CAPACITY)

# https://developer.android.com/reference/android/os/BatteryManager
(de BATTERY_PROPERTY_CURRENT_NOW . 2)
(de BATTERY_PROPERTY_CURRENT_AVERAGE . 3)
(de BATTERY_PROPERTY_CAPACITY . 4)


(symbols 'pico~battery 'android 'pico)

(local) (*Sse1 *Sse2 *Sse3)

(start
   (setq *BatteryManager
      (java CONTEXT 'getSystemService "batterymanager") )
   (task -997 200
      (serverSend *Sse1
         (prin (format (java *BatteryManager 'getIntProperty BATTERY_PROPERTY_CURRENT_NOW) 3)) )
      (serverSend *Sse2
         (prin (format (java *BatteryManager 'getIntProperty BATTERY_PROPERTY_CURRENT_AVERAGE) 3)) )
      (serverSend *Sse3
         (prin (java *BatteryManager 'getIntProperty BATTERY_PROPERTY_CAPACITY)) ) ) )

(stop
   (task -997) )

(menu "Battery"
   (<h2> "center" "Battery Status")
   (<table> "bat" NIL '(("em15") ("align em10") ("em3"))
      (<row> NIL "Charging" (<div> '(id . "bat1")) " mA")
      (<row> NIL "Average" (<div> '(id . "bat2")) " mA")
      (<row> NIL "Capacity" (<div> '(id . "bat3")) " %") )
   (serverSentEvent "bat1" '*Sse1)
   (serverSentEvent "bat2" '*Sse2)
   (serverSentEvent "bat3" '*Sse3) )
